from __future__ import division, absolute_import, print_function

from distutils.unixccompiler import UnixCCompiler

class ArmClangCCompiler(UnixCCompiler):

    """
    Arm HPC compiler.
    """

    compiler_type = 'armclang'
    cc_exe = 'armclang -fPIC -DPIC'
    cxx_exe = 'armclang++ -fPIC -DPIC'

    def __init__ (self, verbose=0, dry_run=0, force=0):
        UnixCCompiler.__init__ (self, verbose, dry_run, force)
        cc_compiler = self.cc_exe
        cxx_compiler = self.cxx_exe
        self.set_executables(compiler=cc_compiler,
                             compiler_so=cc_compiler,
                             compiler_cxx=cxx_compiler,
                             linker_exe=cc_compiler,
                             linker_so=cc_compiler + ' -shared -rtlib=compiler-rt')
